/* $ANTLR 2.7.6 (20060903): "bibcommand.g" -> "bibcommandparser.cpp"$ */
#include "bibcommandparser.hpp"
#include <antlr/NoViableAltException.hpp>
#include <antlr/SemanticException.hpp>
#include <antlr/ASTFactory.hpp>
#line 40 "bibcommand.g"

// Will be included before parser methods implementations
// in parser.cpp
#include "bibcommandlexer.hpp"
#include <sstream>
#include <iostream>

using namespace std;
using namespace xdkbib;

void bibcommandparser::setBraceStartsValue(bool b)
{
bibcommandlexer* l =
dynamic_cast<bibcommandlexer*>(pbf_->selector()->getCurrentStream());
if (l)
{
l->setBraceStartsValue(b);
}
else
{
cout<<"cannot cast to bibcommandlexer"<<endl;
}
}
void bibcommandparser::addPart(ValuePartType t,const string& v)
{
currentValueParts_.push_back(ValuePart(t,v));
}

#line 36 "bibcommandparser.cpp"
bibcommandparser::bibcommandparser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf, int k)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(tokenBuf,k)
{
}

bibcommandparser::bibcommandparser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(tokenBuf,2)
{
}

bibcommandparser::bibcommandparser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer, int k)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(lexer,k)
{
}

bibcommandparser::bibcommandparser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(lexer,2)
{
}

bibcommandparser::bibcommandparser(const ANTLR_USE_NAMESPACE(antlr)ParserSharedInputState& state)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(state,2)
{
}

void bibcommandparser::parse() {
#line 90 "bibcommand.g"
	
	string i;
	string s;
	
#line 68 "bibcommandparser.cpp"
	
#line 96 "bibcommand.g"
	
	setBraceStartsValue(false);
	
#line 74 "bibcommandparser.cpp"
	{
	switch ( LA(1)) {
	case TYPE:
	{
		entry();
		break;
	}
	case STRINGDEF:
	{
		stringdef();
		break;
	}
	case PREAMBLE:
	{
		preamble();
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
}

void bibcommandparser::entry() {
	ANTLR_USE_NAMESPACE(antlr)RefToken  t = ANTLR_USE_NAMESPACE(antlr)nullToken;
#line 156 "bibcommand.g"
	
	string k;
	
#line 106 "bibcommandparser.cpp"
	
	t = LT(1);
	match(TYPE);
	{
	switch ( LA(1)) {
	case LBRACE:
	{
		{
		match(LBRACE);
		k=key();
		match(COMA);
#line 162 "bibcommand.g"
		
		int l = t->getLine();
		#ifdef PARSER_DEBUG_MODE
		cout<<"PARSER_DEBUG:parsing entry "<<k<<"["<<l<<"]"<<endl;
		#endif
		setBraceStartsValue(true);
		currentEntry_ = pbf_->file()->addEntry(Entry(t->getText(),
		k,l));
		
#line 128 "bibcommandparser.cpp"
		fields();
		match(RBRACE);
		}
		break;
	}
	case LPARENTHESIS:
	{
		{
		match(LPARENTHESIS);
		k=key();
		match(COMA);
#line 174 "bibcommand.g"
		
		int l = t->getLine();
		setBraceStartsValue(true);
		currentEntry_ = pbf_->file()->addEntry(Entry(t->getText(),
		k,l));
		
#line 147 "bibcommandparser.cpp"
		fields();
		match(RPARENTHESIS);
		}
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
#line 183 "bibcommand.g"
	
	currentEntry_->setComment(pbf_->currentComment());
	pbf_->clearCurrentComment();
	
#line 164 "bibcommandparser.cpp"
}

void bibcommandparser::stringdef() {
#line 101 "bibcommand.g"
	
	string i;
	
#line 172 "bibcommandparser.cpp"
	
	match(STRINGDEF);
#line 106 "bibcommand.g"
	
	setBraceStartsValue(true);
	
#line 179 "bibcommandparser.cpp"
	{
	switch ( LA(1)) {
	case LPARENTHESIS:
	{
		{
		match(LPARENTHESIS);
		i=id();
		match(EQUAL);
		fieldValue();
		match(RPARENTHESIS);
#line 110 "bibcommand.g"
		
		pbf_->file()->defineString(i,
		currentValueParts_.begin(),
		currentValueParts_.end());
		
#line 196 "bibcommandparser.cpp"
		}
		break;
	}
	case LBRACE:
	{
		{
		match(LBRACE);
		i=id();
		match(EQUAL);
		fieldValue();
		match(RBRACE);
#line 117 "bibcommand.g"
		
		pbf_->file()->defineString(i,
		currentValueParts_.begin(),
		currentValueParts_.end());
		
#line 214 "bibcommandparser.cpp"
		}
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
}

void bibcommandparser::preamble() {
	
	match(PREAMBLE);
#line 127 "bibcommand.g"
	
	setBraceStartsValue(true);
	
#line 233 "bibcommandparser.cpp"
	{
	switch ( LA(1)) {
	case LBRACE:
	{
		{
		match(LBRACE);
		fieldValue();
		match(RBRACE);
#line 131 "bibcommand.g"
		
		bool newline = true;
		for (list<ValuePart>::const_iterator
		iter = currentValueParts_.begin();
		iter != currentValueParts_.end();++iter)
		{
		pbf_->file()->addToPreamble(*iter,newline);
		newline = false;
		}
		
#line 253 "bibcommandparser.cpp"
		}
		break;
	}
	case LPARENTHESIS:
	{
		{
		match(LPARENTHESIS);
		fieldValue();
		match(RPARENTHESIS);
#line 143 "bibcommand.g"
		
		bool newline = true;
		for (list<ValuePart>::const_iterator
		iter = currentValueParts_.begin();
		iter != currentValueParts_.end();++iter)
		{
		pbf_->file()->addToPreamble(*iter,newline);
		newline = false;
		}
		
#line 274 "bibcommandparser.cpp"
		}
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
}

std::string  bibcommandparser::id() {
#line 255 "bibcommand.g"
	std::string v;
#line 289 "bibcommandparser.cpp"
	ANTLR_USE_NAMESPACE(antlr)RefToken  t = ANTLR_USE_NAMESPACE(antlr)nullToken;
	
	t = LT(1);
	match(NAME);
#line 257 "bibcommand.g"
	
	v = string(t->getText());
	
#line 298 "bibcommandparser.cpp"
	return v;
}

void bibcommandparser::fieldValue() {
	
#line 218 "bibcommand.g"
	
	currentValueParts_.clear();
	
#line 308 "bibcommandparser.cpp"
	fieldValuePart();
	{ // ( ... )*
	for (;;) {
		if ((LA(1) == POUND)) {
			match(POUND);
			fieldValuePart();
		}
		else {
			goto _loop22;
		}
		
	}
	_loop22:;
	} // ( ... )*
}

std::string  bibcommandparser::key() {
#line 245 "bibcommand.g"
	std::string v;
#line 328 "bibcommandparser.cpp"
	ANTLR_USE_NAMESPACE(antlr)RefToken  t = ANTLR_USE_NAMESPACE(antlr)nullToken;
	ANTLR_USE_NAMESPACE(antlr)RefToken  s = ANTLR_USE_NAMESPACE(antlr)nullToken;
	
	switch ( LA(1)) {
	case NAME:
	{
		t = LT(1);
		match(NAME);
#line 247 "bibcommand.g"
		
		v = string(t->getText());
		
#line 341 "bibcommandparser.cpp"
		break;
	}
	case NUMBER:
	{
		s = LT(1);
		match(NUMBER);
#line 251 "bibcommand.g"
		
		v = string(s->getText());
		
#line 352 "bibcommandparser.cpp"
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	return v;
}

void bibcommandparser::fields() {
	
	field();
	{ // ( ... )*
	for (;;) {
		if ((LA(1) == COMA) && (LA(2) == NAME)) {
			match(COMA);
			field();
		}
		else {
			goto _loop17;
		}
		
	}
	_loop17:;
	} // ( ... )*
	{
	switch ( LA(1)) {
	case COMA:
	{
		match(COMA);
		break;
	}
	case RPARENTHESIS:
	case RBRACE:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	}
}

void bibcommandparser::field() {
	ANTLR_USE_NAMESPACE(antlr)RefToken  e = ANTLR_USE_NAMESPACE(antlr)nullToken;
#line 191 "bibcommand.g"
	
	string i;
	
#line 405 "bibcommandparser.cpp"
	
	i=id();
	e = LT(1);
	match(EQUAL);
	fieldValue();
#line 196 "bibcommand.g"
	
	#ifdef PARSER_DEBUG_MODE
	cout<<"PARSER_DEBUG:  parsing field "<<i<<"["<<l<<"]"<<endl;
	#endif
	int l = e->getLine();
	FieldHandle h = currentEntry_->field(i);
	if (h.isMissing())
	{
	currentEntry_->addField(i,l).append(currentValueParts_.begin(),currentValueParts_.end());
	}
	else
	{
	int l = e->getLine();
	ostringstream os;
	os<<"multiple field "<<i<<" in "<<currentEntry_->key()
	<<" -> extra ignored";
	pbf_->issueWarning(os.str(),getFilename(),l);
	}            
	
#line 431 "bibcommandparser.cpp"
}

void bibcommandparser::fieldValuePart() {
	ANTLR_USE_NAMESPACE(antlr)RefToken  t0 = ANTLR_USE_NAMESPACE(antlr)nullToken;
	ANTLR_USE_NAMESPACE(antlr)RefToken  t1 = ANTLR_USE_NAMESPACE(antlr)nullToken;
	ANTLR_USE_NAMESPACE(antlr)RefToken  t2 = ANTLR_USE_NAMESPACE(antlr)nullToken;
	ANTLR_USE_NAMESPACE(antlr)RefToken  t3 = ANTLR_USE_NAMESPACE(antlr)nullToken;
	
	switch ( LA(1)) {
	case NAME:
	{
		t0 = LT(1);
		match(NAME);
#line 225 "bibcommand.g"
		
		addPart(String,t0->getText());
		// Issue a warning if the name is not defined although it
		// does not prevent us from creating a value part.
		try {
		(void) pbf_->file()->stringText(t0->getText());
		}
		catch (range_error& e)
		{
		int l = t0->getLine();
		ostringstream os;
		os<<"string name \""<<t0->getText()<<"\" is undefined";
		pbf_->issueWarning(os.str(),getFilename(),l);
		addPart(String,t0->getText());
		}
		
#line 462 "bibcommandparser.cpp"
		break;
	}
	case STRING:
	{
		t1 = LT(1);
		match(STRING);
#line 241 "bibcommand.g"
		addPart(Quoted,t1->getText());
#line 471 "bibcommandparser.cpp"
		break;
	}
	case VALUE:
	{
		t2 = LT(1);
		match(VALUE);
#line 242 "bibcommand.g"
		addPart(Braced,t2->getText());
#line 480 "bibcommandparser.cpp"
		break;
	}
	case NUMBER:
	{
		t3 = LT(1);
		match(NUMBER);
#line 243 "bibcommand.g"
		addPart(Number,t3->getText());
#line 489 "bibcommandparser.cpp"
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
}

void bibcommandparser::initializeASTFactory( ANTLR_USE_NAMESPACE(antlr)ASTFactory& )
{
}
const char* bibcommandparser::tokenNames[] = {
	"<0>",
	"EOF",
	"<2>",
	"NULL_TREE_LOOKAHEAD",
	"STRINGDEF",
	"LPARENTHESIS",
	"EQUAL",
	"RPARENTHESIS",
	"LBRACE",
	"RBRACE",
	"PREAMBLE",
	"TYPE",
	"COMA",
	"POUND",
	"NAME",
	"STRING",
	"VALUE",
	"NUMBER",
	"ESC",
	"ESC_WITH_QUOTE",
	"STRING_INTERNAL_WITH_QUOTES",
	"STRING_INTERNAL",
	"VALUE_INTERNAL",
	"LBRACE_OR_VALUE",
	"WS",
	"STRINGDEF_OR_PREAMBLE_OR_TYPE",
	0
};



