/* $ANTLR 2.7.6 (20060903): "bibfile.g" -> "bibfileparser.cpp"$ */
#include "bibfileparser.hpp"
#include <antlr/NoViableAltException.hpp>
#include <antlr/SemanticException.hpp>
#include <antlr/ASTFactory.hpp>
#line 36 "bibfile.g"

// Will be included before parser methods implementations
// in parser.cpp
#include "bibcommandparser.hpp"
#include <iostream>

using namespace std;

#line 16 "bibfileparser.cpp"
bibfileparser::bibfileparser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf, int k)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(tokenBuf,k)
{
}

bibfileparser::bibfileparser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(tokenBuf,1)
{
}

bibfileparser::bibfileparser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer, int k)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(lexer,k)
{
}

bibfileparser::bibfileparser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(lexer,1)
{
}

bibfileparser::bibfileparser(const ANTLR_USE_NAMESPACE(antlr)ParserSharedInputState& state)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(state,1)
{
}

void bibfileparser::parse() {
	
	{ // ( ... )*
	for (;;) {
		switch ( LA(1)) {
		case COMMENT:
		{
			comment();
			break;
		}
		case ARROBAS:
		{
			bibcommand();
			break;
		}
		default:
		{
			goto _loop3;
		}
		}
	}
	_loop3:;
	} // ( ... )*
	match(ANTLR_USE_NAMESPACE(antlr)Token::EOF_TYPE);
#line 64 "bibfile.g"
	
	pbf_->file()->setComment(pbf_->currentComment());
	pbf_->clearCurrentComment();
	
#line 71 "bibfileparser.cpp"
}

void bibfileparser::comment() {
	ANTLR_USE_NAMESPACE(antlr)RefToken  c = ANTLR_USE_NAMESPACE(antlr)nullToken;
	
	c = LT(1);
	match(COMMENT);
#line 72 "bibfile.g"
	
	pbf_->addToCurrentComment(c->getText()); 
	
#line 83 "bibfileparser.cpp"
}

void bibfileparser::bibcommand() {
	
	match(ARROBAS);
#line 78 "bibfile.g"
	
	bibcommandparser p(getInputState());
	p.setParsedBibFile(pbf_);
	p.parse();
	
#line 95 "bibfileparser.cpp"
}

void bibfileparser::initializeASTFactory( ANTLR_USE_NAMESPACE(antlr)ASTFactory& )
{
}
const char* bibfileparser::tokenNames[] = {
	"<0>",
	"EOF",
	"<2>",
	"NULL_TREE_LOOKAHEAD",
	"COMMENT",
	"ARROBAS",
	"ARROBASCOMMENT",
	"ARROBAS_OR_COMMENT",
	0
};



